	program kga
	real wij(100,100),wjk(100,100),xmin(2,100),xmax(2,100)
	real x(100),xmod(2,100),y(100)
*       the file "kga.w" contains neural model parameters:
	open(1,file="kga.w",status="old")	 
	read(1,*) ii,jj,kk
	do 10 i=1,ii
	  read(1,*) xmax(1,i),xmin(1,i),xmod(1,i)
10	continue
	do 20 i=1,kk
	  read(1,*) xmax(2,i),xmin(2,i),xmod(2,i)
20	continue
       	do 30 i=1,ii+1
	  read(1,*) (wij(i,j),j=1,jj)
30        continue
	do 40 j=1,jj+1
	  read(1,*) (wjk(j,k),k=1,kk)
40        continue
********************Input data**********************
*LIQUID PROPERTIES 					

*density kg/m3
	rol = 1090
*viscosity kg/m.s
	xmul = .00166
*surface tension kg/s2
	sigl = .0775
*superficial velocity m/s
	ul = .00183

*GAS PROPERTIES
*density kg/m3
	rog = 1.17
*viscosity kg/m.s
	xmug = 1.81e-05   
*superficial velocity m/s
	ug =0.0506    

*SOLUTE PROPERTIES
*diffusion coefficient of solute in liquid m2/s            
	da = 1.4e-05 

*PARTICLE AND BED PROPERTIES
*equivalent grain diameter m
	dv = .0024             
*sphericity 
	phi =1.
*porosity 
	eps =.365
*column diameter m
	dc = .05            
********************************************
	
     	rel = dv * rol * ul / xmul
	stl=xmul*ul/rol/9.8/dv**2.
	webg=ug**2.*dv*rog/sigl
	xg=ug*rog**0.5/(ul*rol**0.5)	
	scg=xmug/(da*rog)
	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
	dh = dv * (16. * eps**3. / 9. / 3.14 / (1. - eps)**2.)**.33
	sb = spsa * dh / (1. - eps)
	x(1)= rel
	x(2)=stl
	x(3)=webg
	x(4)=xg
	x(5)=scg
	x(6)=sb
	write(6,*) (x(i),i=1,6)
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y)	
*       gas sherwood number prediction is y(1)
	write(6,*) y(1)
	end
	subroutine fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y)
	real wij(100,100),wjk(100,100),xmin(2,100),xmax(2,100)
	real x(100),u(100),h(100),s(100),xmod(2,100),y(100)
*       neural network equations:
	  do 100 i=1,ii
	  if (xmod(1,i).eq.0.) then
	    u(i)=(x(i)-xmin(1,i))/(xmax(1,i)-xmin(1,i))
	  else
	    u(i)=(log10(x(i))-xmin(1,i))/(xmax(1,i)-xmin(1,i))
	  endif
100       continue
	  u(ii+1)=1.
          do 110 j=1,jj
            h(j)=0.
            do 120 i=1,ii+1
120         h(j)=h(j)+wij(i,j)*u(i)
	    print*,j,h(j)
110       h(j)=1./(1.+exp(-h(j)))
          h(jj+1)=1.
          do 130 k=1,kk
            s(k)=0.
            do 140 j=1,jj+1
140         s(k)=s(k)+wjk(j,k)*h(j)
          s(k)=1./(1.+exp(-s(k)))
          y(k)=xmin(2,k)+s(k)*(xmax(2,k)-xmin(2,k))
          if(xmod(2,k).eq.1.) then
            y(k)=10.**(y(k))
          endif
130       continue 
	  return
          end
